2003-10-27 Marco Gerards <metgerards@student.han.nl>

* README: In the pupa-mkimage example use _chain instead of chain
	and ext2 instead of fat.
	* TODO: Replace ext2fs with jfs as an example.  Add an item for
	adding journal playback for ext2fs.
	* conf/i386-pc.rmk (pupa_setup_SOURCES): Added fs/ext2.c.
	(pkgdata_MODULES): Added ext2.mod.
	(ext2_mod_SOURCES): New variable.
	(ext2_mod_CFLAGS): Likewise.
	* include/pupa/err.h (pupa_err_t): Added PUPA_ERR_SYMLINK_LOOP.
	* include/pupa/misc.h (pupa_strncpy): New prototype.
	(pupa_strcat): Likewise.
	(pupa_strncmp): Likewise.
	* kern/misc.c (pupa_strcat): Enable function.
	(pupa_strncpy): New function.
	(pupa_strncmp): Likewise.

	* kern/disk.c (pupa_disk_read): Set pupa_errno to PUPA_ERR_NONE
	when the read failed before retrying.
	* util/i386/pc/biosdisk.c (_LARGEFILE_SOURCE): Removed.
	(_FILE_OFFSET_BITS): Likewise.
	* configure.ac: Added AC_SYS_LARGEFILE.
This commit is contained in:
marco_g 2003-10-29 18:44:30 +00:00
parent 98d150633e
commit a35eed7c3e
13 changed files with 1149 additions and 18 deletions

2
README
View File

@ -18,7 +18,7 @@ use (yet). For now, you can install PUPA into a floppy by these
instructions:
$ configure && make
$ ./pupa-mkimage -v -d . -o core.img chain fat
$ ./pupa-mkimage -v -d . -o core.img _chain ext2
$ dd if=boot.img of=/dev/fd0 bs=512 count=1
$ dd if=core.img of=/dev/fd0 bs=512 seek=1

4
TODO
View File

@ -13,7 +13,9 @@ Priorities:
higher priority.
* Add more filesystems (such as ext2fs, ffs, and reiserfs). !
* Add more filesystems (such as jfs, ffs, and reiserfs). !
* Add journal playback support to ext2fs (so it will become ext3fs).
* Add support for internationalization. !!!

View File

@ -280,11 +280,11 @@ pupa_mkimage_LDFLAGS = -llzo
# For pupa-setup.
pupa_setup_SOURCES = util/i386/pc/pupa-setup.c util/i386/pc/biosdisk.c \
util/misc.c kern/device.c kern/disk.c kern/file.c kern/fs.c \
kern/err.c kern/misc.c disk/i386/pc/partition.c fs/fat.c
CLEANFILES += pupa-setup pupa_setup-util_i386_pc_pupa_setup.o pupa_setup-util_i386_pc_biosdisk.o pupa_setup-util_misc.o pupa_setup-kern_device.o pupa_setup-kern_disk.o pupa_setup-kern_file.o pupa_setup-kern_fs.o pupa_setup-kern_err.o pupa_setup-kern_misc.o pupa_setup-disk_i386_pc_partition.o pupa_setup-fs_fat.o
MOSTLYCLEANFILES += pupa_setup-util_i386_pc_pupa_setup.d pupa_setup-util_i386_pc_biosdisk.d pupa_setup-util_misc.d pupa_setup-kern_device.d pupa_setup-kern_disk.d pupa_setup-kern_file.d pupa_setup-kern_fs.d pupa_setup-kern_err.d pupa_setup-kern_misc.d pupa_setup-disk_i386_pc_partition.d pupa_setup-fs_fat.d
kern/err.c kern/misc.c disk/i386/pc/partition.c fs/fat.c fs/ext2.c
CLEANFILES += pupa-setup pupa_setup-util_i386_pc_pupa_setup.o pupa_setup-util_i386_pc_biosdisk.o pupa_setup-util_misc.o pupa_setup-kern_device.o pupa_setup-kern_disk.o pupa_setup-kern_file.o pupa_setup-kern_fs.o pupa_setup-kern_err.o pupa_setup-kern_misc.o pupa_setup-disk_i386_pc_partition.o pupa_setup-fs_fat.o pupa_setup-fs_ext2.o
MOSTLYCLEANFILES += pupa_setup-util_i386_pc_pupa_setup.d pupa_setup-util_i386_pc_biosdisk.d pupa_setup-util_misc.d pupa_setup-kern_device.d pupa_setup-kern_disk.d pupa_setup-kern_file.d pupa_setup-kern_fs.d pupa_setup-kern_err.d pupa_setup-kern_misc.d pupa_setup-disk_i386_pc_partition.d pupa_setup-fs_fat.d pupa_setup-fs_ext2.d
pupa-setup: pupa_setup-util_i386_pc_pupa_setup.o pupa_setup-util_i386_pc_biosdisk.o pupa_setup-util_misc.o pupa_setup-kern_device.o pupa_setup-kern_disk.o pupa_setup-kern_file.o pupa_setup-kern_fs.o pupa_setup-kern_err.o pupa_setup-kern_misc.o pupa_setup-disk_i386_pc_partition.o pupa_setup-fs_fat.o
pupa-setup: pupa_setup-util_i386_pc_pupa_setup.o pupa_setup-util_i386_pc_biosdisk.o pupa_setup-util_misc.o pupa_setup-kern_device.o pupa_setup-kern_disk.o pupa_setup-kern_file.o pupa_setup-kern_fs.o pupa_setup-kern_err.o pupa_setup-kern_misc.o pupa_setup-disk_i386_pc_partition.o pupa_setup-fs_fat.o pupa_setup-fs_ext2.o
$(BUILD_CC) -o $@ $^ $(BUILD_LDFLAGS) $(pupa_setup_LDFLAGS)
pupa_setup-util_i386_pc_pupa_setup.o: util/i386/pc/pupa-setup.c
@ -375,6 +375,14 @@ pupa_setup-fs_fat.d: fs/fat.c
-include pupa_setup-fs_fat.d
pupa_setup-fs_ext2.o: fs/ext2.c
$(BUILD_CC) -Ifs -I$(srcdir)/fs $(BUILD_CPPFLAGS) $(BUILD_CFLAGS) -DPUPA_UTIL=1 $(pupa_setup_CFLAGS) -c -o $@ $<
pupa_setup-fs_ext2.d: fs/ext2.c
set -e; $(BUILD_CC) -Ifs -I$(srcdir)/fs $(BUILD_CPPFLAGS) $(BUILD_CFLAGS) -DPUPA_UTIL=1 $(pupa_setup_CFLAGS) -M $< | sed 's,ext2\.o[ :]*,pupa_setup-fs_ext2.o $@ : ,g' > $@; [ -s $@ ] || rm -f $@
-include pupa_setup-fs_ext2.d
# For genmoddep.
genmoddep_SOURCES = util/genmoddep.c
@ -394,7 +402,7 @@ genmoddep-util_genmoddep.d: util/genmoddep.c
# Modules.
pkgdata_MODULES = _chain.mod _linux.mod fat.mod normal.mod hello.mod \
pkgdata_MODULES = _chain.mod _linux.mod fat.mod ext2.mod normal.mod hello.mod \
vga.mod font.mod
# For _chain.mod.
@ -475,6 +483,45 @@ fat_mod-fs_fat.d: fs/fat.c
fat_mod_CFLAGS = $(COMMON_CFLAGS)
# For ext2.mod.
ext2_mod_SOURCES = fs/ext2.c
CLEANFILES += ext2.mod mod-ext2.o mod-ext2.c pre-ext2.o ext2_mod-fs_ext2.o def-ext2.lst und-ext2.lst
MOSTLYCLEANFILES += ext2_mod-fs_ext2.d
DEFSYMFILES += def-ext2.lst
UNDSYMFILES += und-ext2.lst
ext2.mod: pre-ext2.o mod-ext2.o
-rm -f $@
$(LD) -r -o $@ $^
$(STRIP) --strip-unneeded -K pupa_mod_init -K pupa_mod_fini -R .note -R .comment $@
pre-ext2.o: ext2_mod-fs_ext2.o
-rm -f $@
$(LD) -r -o $@ $^
mod-ext2.o: mod-ext2.c
$(CC) $(CPPFLAGS) $(CFLAGS) $(ext2_mod_CFLAGS) -c -o $@ $<
mod-ext2.c: moddep.lst genmodsrc.sh
sh $(srcdir)/genmodsrc.sh 'ext2' $< > $@ || (rm -f $@; exit 1)
def-ext2.lst: pre-ext2.o
$(NM) -g --defined-only -P -p $< | sed 's/^\([^ ]*\).*/\1 ext2/' > $@
und-ext2.lst: pre-ext2.o
echo 'ext2' > $@
$(NM) -u -P -p $< | cut -f1 -d' ' >> $@
ext2_mod-fs_ext2.o: fs/ext2.c
$(CC) -Ifs -I$(srcdir)/fs $(CPPFLAGS) $(CFLAGS) $(ext2_mod_CFLAGS) -c -o $@ $<
ext2_mod-fs_ext2.d: fs/ext2.c
set -e; $(CC) -Ifs -I$(srcdir)/fs $(CPPFLAGS) $(CFLAGS) $(ext2_mod_CFLAGS) -M $< | sed 's,ext2\.o[ :]*,ext2_mod-fs_ext2.o $@ : ,g' > $@; [ -s $@ ] || rm -f $@
-include ext2_mod-fs_ext2.d
ext2_mod_CFLAGS = $(COMMON_CFLAGS)
# For _linux.mod.
_linux_mod_SOURCES = loader/i386/pc/linux.c
CLEANFILES += _linux.mod mod-_linux.o mod-_linux.c pre-_linux.o _linux_mod-loader_i386_pc_linux.o def-_linux.lst und-_linux.lst

View File

@ -55,13 +55,13 @@ pupa_mkimage_LDFLAGS = -llzo
# For pupa-setup.
pupa_setup_SOURCES = util/i386/pc/pupa-setup.c util/i386/pc/biosdisk.c \
util/misc.c kern/device.c kern/disk.c kern/file.c kern/fs.c \
kern/err.c kern/misc.c disk/i386/pc/partition.c fs/fat.c
kern/err.c kern/misc.c disk/i386/pc/partition.c fs/fat.c fs/ext2.c
# For genmoddep.
genmoddep_SOURCES = util/genmoddep.c
# Modules.
pkgdata_MODULES = _chain.mod _linux.mod fat.mod normal.mod hello.mod \
pkgdata_MODULES = _chain.mod _linux.mod fat.mod ext2.mod normal.mod hello.mod \
vga.mod font.mod
# For _chain.mod.
@ -72,6 +72,10 @@ _chain_mod_CFLAGS = $(COMMON_CFLAGS)
fat_mod_SOURCES = fs/fat.c
fat_mod_CFLAGS = $(COMMON_CFLAGS)
# For ext2.mod.
ext2_mod_SOURCES = fs/ext2.c
ext2_mod_CFLAGS = $(COMMON_CFLAGS)
# For _linux.mod.
_linux_mod_SOURCES = loader/i386/pc/linux.c
_linux_mod_CFLAGS = $(COMMON_CFLAGS)

View File

@ -79,3 +79,9 @@
/* Define to 1 if your processor stores words with the most significant byte
first (like Motorola and SPARC, unlike Intel and VAX). */
#undef WORDS_BIGENDIAN
/* Number of bits in a file offset, on hosts where this is settable. */
#undef _FILE_OFFSET_BITS
/* Define for large files, on AIX-style hosts. */
#undef _LARGE_FILES

318
configure vendored
View File

@ -844,6 +844,11 @@ if test -n "$ac_init_help"; then
esac
cat <<\_ACEOF
Optional Features:
--disable-FEATURE do not include FEATURE (same as --enable-FEATURE=no)
--enable-FEATURE[=ARG] include FEATURE [ARG=yes]
--disable-largefile omit support for large files
Some influential environment variables:
CC C compiler command
CFLAGS C compiler flags
@ -2247,6 +2252,316 @@ ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $
ac_compiler_gnu=$ac_cv_c_compiler_gnu
# Check whether --enable-largefile or --disable-largefile was given.
if test "${enable_largefile+set}" = set; then
enableval="$enable_largefile"
fi;
if test "$enable_largefile" != no; then
echo "$as_me:$LINENO: checking for special C compiler options needed for large files" >&5
echo $ECHO_N "checking for special C compiler options needed for large files... $ECHO_C" >&6
if test "${ac_cv_sys_largefile_CC+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_cv_sys_largefile_CC=no
if test "$GCC" != yes; then
ac_save_CC=$CC
while :; do
# IRIX 6.2 and later do not support large files by default,
# so use the C compiler's -n32 option if that helps.
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <sys/types.h>
/* Check that off_t can represent 2**63 - 1 correctly.
We can't simply define LARGE_OFF_T to be 9223372036854775807,
since some C++ compilers masquerading as C compilers
incorrectly reject 9223372036854775807. */
#define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721
&& LARGE_OFF_T % 2147483647 == 1)
? 1 : -1];
int
main ()
{
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext
CC="$CC -n32"
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_cv_sys_largefile_CC=' -n32'; break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext
break
done
CC=$ac_save_CC
rm -f conftest.$ac_ext
fi
fi
echo "$as_me:$LINENO: result: $ac_cv_sys_largefile_CC" >&5
echo "${ECHO_T}$ac_cv_sys_largefile_CC" >&6
if test "$ac_cv_sys_largefile_CC" != no; then
CC=$CC$ac_cv_sys_largefile_CC
fi
echo "$as_me:$LINENO: checking for _FILE_OFFSET_BITS value needed for large files" >&5
echo $ECHO_N "checking for _FILE_OFFSET_BITS value needed for large files... $ECHO_C" >&6
if test "${ac_cv_sys_file_offset_bits+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
while :; do
ac_cv_sys_file_offset_bits=no
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <sys/types.h>
/* Check that off_t can represent 2**63 - 1 correctly.
We can't simply define LARGE_OFF_T to be 9223372036854775807,
since some C++ compilers masquerading as C compilers
incorrectly reject 9223372036854775807. */
#define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721
&& LARGE_OFF_T % 2147483647 == 1)
? 1 : -1];
int
main ()
{
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext conftest.$ac_ext
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#define _FILE_OFFSET_BITS 64
#include <sys/types.h>
/* Check that off_t can represent 2**63 - 1 correctly.
We can't simply define LARGE_OFF_T to be 9223372036854775807,
since some C++ compilers masquerading as C compilers
incorrectly reject 9223372036854775807. */
#define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721
&& LARGE_OFF_T % 2147483647 == 1)
? 1 : -1];
int
main ()
{
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_cv_sys_file_offset_bits=64; break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext conftest.$ac_ext
break
done
fi
echo "$as_me:$LINENO: result: $ac_cv_sys_file_offset_bits" >&5
echo "${ECHO_T}$ac_cv_sys_file_offset_bits" >&6
if test "$ac_cv_sys_file_offset_bits" != no; then
cat >>confdefs.h <<_ACEOF
#define _FILE_OFFSET_BITS $ac_cv_sys_file_offset_bits
_ACEOF
fi
rm -f conftest*
echo "$as_me:$LINENO: checking for _LARGE_FILES value needed for large files" >&5
echo $ECHO_N "checking for _LARGE_FILES value needed for large files... $ECHO_C" >&6
if test "${ac_cv_sys_large_files+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
while :; do
ac_cv_sys_large_files=no
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <sys/types.h>
/* Check that off_t can represent 2**63 - 1 correctly.
We can't simply define LARGE_OFF_T to be 9223372036854775807,
since some C++ compilers masquerading as C compilers
incorrectly reject 9223372036854775807. */
#define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721
&& LARGE_OFF_T % 2147483647 == 1)
? 1 : -1];
int
main ()
{
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext conftest.$ac_ext
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#define _LARGE_FILES 1
#include <sys/types.h>
/* Check that off_t can represent 2**63 - 1 correctly.
We can't simply define LARGE_OFF_T to be 9223372036854775807,
since some C++ compilers masquerading as C compilers
incorrectly reject 9223372036854775807. */
#define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721
&& LARGE_OFF_T % 2147483647 == 1)
? 1 : -1];
int
main ()
{
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_cv_sys_large_files=1; break
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
fi
rm -f conftest.$ac_objext conftest.$ac_ext
break
done
fi
echo "$as_me:$LINENO: result: $ac_cv_sys_large_files" >&5
echo "${ECHO_T}$ac_cv_sys_large_files" >&6
if test "$ac_cv_sys_large_files" != no; then
cat >>confdefs.h <<_ACEOF
#define _LARGE_FILES $ac_cv_sys_large_files
_ACEOF
fi
rm -f conftest*
fi
# Must be GCC.
test "x$GCC" = xyes || { { echo "$as_me:$LINENO: error: GCC is required" >&5
echo "$as_me: error: GCC is required" >&2;}
@ -2258,8 +2573,7 @@ if test "x$default_CFLAGS" = xyes; then
-Wundef -Wstrict-prototypes -g"
# optimization flags.
echo "$as_me:$LINENO: checking whether optimization for size works" >&5
echo "$as_me:$LINENO: checking whether optimization for size works" >&5
echo $ECHO_N "checking whether optimization for size works... $ECHO_C" >&6
if test "${size_flag+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6

View File

@ -39,6 +39,7 @@ if test "x$CFLAGS" = x; then
fi
AC_PROG_CC
AC_SYS_LARGEFILE
# Must be GCC.
test "x$GCC" = xyes || AC_MSG_ERROR([GCC is required])

721
fs/ext2.c Normal file
View File

@ -0,0 +1,721 @@
/* ext2.c - Second Extended filesystem */
/*
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 2003 Marco Gerards <metgerards@student.han.nl>.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* Magic value used to identify an ext2 filesystem. */
#define EXT2_MAGIC 0xEF53
/* Amount of indirect blocks in an inode. */
#define INDIRECT_BLOCKS 12
/* Maximum lenght of a pathname. */
#define EXT2_PATH_MAX 4096
/* Maximum nesting of symlinks, used to prevent a loop. */
#define EXT2_MAX_SYMLINKCNT 8
/* Filetype used in directory entry. */
#define FILETYPE_DIRECTORY 2
#define FILETYPE_SYMLINK 7
#include <pupa/err.h>
#include <pupa/file.h>
#include <pupa/mm.h>
#include <pupa/misc.h>
#include <pupa/disk.h>
#include <pupa/dl.h>
#include <pupa/types.h>
/* Log2 size of ext2 block in 512 blocks. */
#define LOG2_EXT2_BLOCK_SIZE(data) \
(pupa_le_to_cpu32 (data->sblock.log2_block_size) + 1)
/* Log2 size of ext2 block in bytes. */
#define LOG2_BLOCK_SIZE(data) \
(pupa_le_to_cpu32 (data->sblock.log2_block_size) + 10)
/* The size of an ext2 block in bytes. */
#define EXT2_BLOCK_SIZE(data) (1 << LOG2_BLOCK_SIZE(data))
/* The ext2 superblock. */
struct pupa_ext_sblock
{
pupa_uint32_t total_inodes;
pupa_uint32_t total_blocks;
pupa_uint32_t reserved_blocks;
pupa_uint32_t free_blocks;
pupa_uint32_t free_inodes;
pupa_uint32_t first_data_block;
pupa_uint32_t log2_block_size;
pupa_uint32_t log2_fragment_size;
pupa_uint32_t blocks_per_group;
pupa_uint32_t fragments_per_group;
pupa_uint32_t inodes_per_group;
pupa_uint32_t mtime;
pupa_uint32_t utime;
pupa_uint16_t mnt_count;
pupa_uint16_t max_mnt_count;
pupa_uint16_t magic;
pupa_uint16_t fs_state;
pupa_uint16_t error_handling;
pupa_uint16_t minor_revision_level;
pupa_uint32_t lastcheck;
pupa_uint32_t checkinterval;
pupa_uint32_t creator_os;
pupa_uint32_t revision_level;
pupa_uint16_t uid_reserved;
pupa_uint16_t gid_reserved;
pupa_uint32_t first_inode;
pupa_uint16_t inode_size;
pupa_uint16_t block_group_number;
pupa_uint32_t feature_compatibility;
pupa_uint32_t feature_incompat;
pupa_uint32_t feature_ro_compat;
pupa_uint32_t unique_id[4];
char volume_name[16];
char last_mounted_on[64];
pupa_uint32_t compression_info;
};
/* The ext2 blockgroup. */
struct ext2_block_group
{
pupa_uint32_t block_id;
pupa_uint32_t inode_id;
pupa_uint32_t inode_table_id;
pupa_uint16_t free_blocks;
pupa_uint16_t free_inodes;
pupa_uint16_t pad;
pupa_uint32_t reserved[3];
};
/* The ext2 inode. */
struct pupa_ext2_inode
{
pupa_uint16_t mode;
pupa_uint16_t uid;
pupa_uint32_t size;
pupa_uint32_t atime;
pupa_uint32_t ctime;
pupa_uint32_t mtime;
pupa_uint32_t dtime;
pupa_uint16_t gid;
pupa_uint16_t nlinks;
pupa_uint32_t blockcnt; /* Blocks of 512 bytes!! */
pupa_uint32_t flags;
pupa_uint32_t osd1;
union
{
struct datablocks
{
pupa_uint32_t dir_blocks[INDIRECT_BLOCKS];
pupa_uint32_t indir_block;
pupa_uint32_t double_indir_block;
pupa_uint32_t tripple_indir_block;
};
char symlink[60];
};
pupa_uint32_t version;
pupa_uint32_t acl;
pupa_uint32_t dir_acl;
pupa_uint32_t fragment_addr;
pupa_uint32_t osd2[3];
};
/* The header of an ext2 directory entry. */
struct ext2_dirent
{
pupa_uint32_t inode;
pupa_uint16_t direntlen;
pupa_uint8_t namelen;
pupa_uint8_t filetype;
};
/* Information about a "mounted" ext2 filesystem. */
struct pupa_ext2_data
{
struct pupa_ext_sblock sblock;
pupa_disk_t disk;
struct pupa_ext2_inode inode;
};
#ifndef PUPA_UTIL
static pupa_dl_t my_mod;
#endif
/* Read into BLKGRP the blockgroup descriptor of blockgroup GROUP of
the mounted filesystem DATA. */
inline static pupa_err_t
pupa_ext2_blockgroup (struct pupa_ext2_data *data, int group,
struct ext2_block_group *blkgrp)
{
return pupa_disk_read (data->disk,
((pupa_le_to_cpu32 (data->sblock.first_data_block) + 1)
<< LOG2_EXT2_BLOCK_SIZE (data)),
group * sizeof (struct ext2_block_group),
sizeof (struct ext2_block_group), (char *) blkgrp);
}
/* Return in BLOCK the on disk block number of block FILEBLOCK in the
opened file descibed by DATA. If this block is not stored on disk
in case of a sparse file return 0. */
static pupa_err_t
pupa_ext2_get_file_block (struct pupa_ext2_data *data,
int fileblock, int *block)
{
int blknr;
struct pupa_ext2_inode *inode = &data->inode;
/* Direct blocks. */
if (fileblock < INDIRECT_BLOCKS)
blknr = pupa_le_to_cpu32 (inode->dir_blocks[fileblock]);
/* Indirect. */
else if (fileblock < INDIRECT_BLOCKS + EXT2_BLOCK_SIZE (data) / 4)
{
pupa_uint32_t indir[EXT2_BLOCK_SIZE (data) / 4];
if (pupa_disk_read (data->disk, pupa_le_to_cpu32 (inode->indir_block)
<< LOG2_EXT2_BLOCK_SIZE (data),
0, EXT2_BLOCK_SIZE (data), (char *) indir))
return pupa_errno;
blknr = pupa_le_to_cpu32 (indir[fileblock - INDIRECT_BLOCKS]);
}
/* Double indirect. */
else if (fileblock < INDIRECT_BLOCKS + EXT2_BLOCK_SIZE (data) / 4
* (EXT2_BLOCK_SIZE (data) / 4 + 1))
{
unsigned int perblock = EXT2_BLOCK_SIZE (data) / 4;
unsigned int rblock = fileblock - (INDIRECT_BLOCKS
+ EXT2_BLOCK_SIZE (data) / 4);
pupa_uint32_t indir[EXT2_BLOCK_SIZE (data) / 4];
if (pupa_disk_read (data->disk,
pupa_le_to_cpu32 (inode->double_indir_block)
<< LOG2_EXT2_BLOCK_SIZE (data),
0, EXT2_BLOCK_SIZE (data), (char *) indir))
return pupa_errno;
if (pupa_disk_read (data->disk,
pupa_le_to_cpu32 (indir[rblock / perblock])
<< LOG2_EXT2_BLOCK_SIZE (data),
0, EXT2_BLOCK_SIZE (data), (char *) indir))
return pupa_errno;
blknr = pupa_le_to_cpu32 (indir[rblock % perblock]);
}
/* Tripple indirect. */
else
{
pupa_error (PUPA_ERR_NOT_IMPLEMENTED_YET,
"ext2fs doesn't support tripple indirect blocks");
return pupa_errno;
}
*block = blknr;
return 0;
}
/* Read LEN bytes from the file described by DATA starting with byte
POS. Return the amount of read bytes in READ. */
static pupa_err_t
pupa_ext2_read_file (struct pupa_ext2_data *data, int pos,
unsigned int len, char *buf)
{
int i;
int blockcnt;
/* Adjust len so it we can't read past the end of the file. */
if (len > pupa_le_to_cpu32 (data->inode.size))
len = pupa_le_to_cpu32 (data->inode.size);
blockcnt = ((len + pos)
+ EXT2_BLOCK_SIZE (data) - 1) / EXT2_BLOCK_SIZE (data);
for (i = pos / EXT2_BLOCK_SIZE (data); i < blockcnt; i++)
{
int blknr;
int blockoff = pos % EXT2_BLOCK_SIZE (data);
int blockend = (len + pos) % EXT2_BLOCK_SIZE (data);
int skipfirst = 0;
pupa_ext2_get_file_block (data, i, &blknr);
if (pupa_errno)
return pupa_errno;
blknr = blknr << LOG2_EXT2_BLOCK_SIZE (data);
/* First block. */
if (i == pos / EXT2_BLOCK_SIZE (data))
skipfirst = blockoff;
if (!blockend)
blockend = EXT2_BLOCK_SIZE (data);
blockend -= skipfirst;
/* If the block number is 0 this block is not stored on disk but
is zero filled instead. */
if (blknr)
{
pupa_disk_read (data->disk, blknr, skipfirst,
blockend, buf);
if (pupa_errno)
return pupa_errno;
}
else
pupa_memset (buf, EXT2_BLOCK_SIZE (data) - skipfirst, 0);
buf += EXT2_BLOCK_SIZE (data) - skipfirst;
}
return len;
}
/* Read the inode INO for the file described by DATA into INODE. */
static pupa_err_t
pupa_ext2_read_inode (struct pupa_ext2_data *data,
int ino, struct pupa_ext2_inode *inode)
{
struct ext2_block_group blkgrp;
struct pupa_ext_sblock *sblock = &data->sblock;
int inodes_per_block;
unsigned int blkno;
unsigned int blkoff;
/* It is easier to calculate if the first inode is 0. */
ino--;
pupa_ext2_blockgroup (data, ino / pupa_le_to_cpu32 (sblock->inodes_per_group),
&blkgrp);
if (pupa_errno)
return pupa_errno;
inodes_per_block = EXT2_BLOCK_SIZE (data) / 128;
blkno = (ino % pupa_le_to_cpu32 (sblock->inodes_per_group))
/ inodes_per_block;
blkoff = (ino % pupa_le_to_cpu32 (sblock->inodes_per_group))
% inodes_per_block;
/* Read the inode. */
if (pupa_disk_read (data->disk,
((pupa_le_to_cpu32 (blkgrp.inode_table_id) + blkno)
<< LOG2_EXT2_BLOCK_SIZE (data)),
sizeof (struct pupa_ext2_inode) * blkoff,
sizeof (struct pupa_ext2_inode), (char *) inode))
return pupa_errno;
return 0;
}
static struct pupa_ext2_data *
pupa_ext2_mount (pupa_disk_t disk)
{
struct pupa_ext2_data *data;
data = pupa_malloc (sizeof (struct pupa_ext2_data));
if (!data)
return 0;
/* Read the superblock. */
pupa_disk_read (disk, 1 * 2, 0, sizeof (struct pupa_ext_sblock),
(char *) &data->sblock);
if (pupa_errno)
goto fail;
/* Make sure this is an ext2 filesystem. */
if (pupa_le_to_cpu16 (data->sblock.magic) != EXT2_MAGIC)
goto fail;
data->disk = disk;
return data;
fail:
pupa_error (PUPA_ERR_BAD_FS, "not an ext2 filesystem");
pupa_free (data);
return 0;
}
/* Find the file with the pathname PATH on the filesystem described by
DATA. Return its inode number in INO. */
static pupa_err_t
pupa_ext2_find_file (struct pupa_ext2_data *data, const char *path, int *ino)
{
int blocksize = EXT2_BLOCK_SIZE (data)
<< pupa_le_to_cpu32 (data->sblock.log2_block_size);
struct pupa_ext2_inode *inode = &data->inode;
int currinode = 2;
int symlinkcnt = 0;
char fpath[EXT2_PATH_MAX];
char *name = fpath;
pupa_strncpy (fpath, path, EXT2_PATH_MAX);
if (!name || name[0] != '/')
{
pupa_error (PUPA_ERR_BAD_FILENAME, "bad filename");
return pupa_errno;
}
/* Skip the first slash. */
name++;
if (!*name)
{
*ino = 2;
return 0;
}
/* Remove trailing "/". */
if (name[pupa_strlen (name) - 1] =='/')
name[pupa_strlen (name) - 1] = '\0';
while (*name)
{
unsigned int fpos = 0;
char *next;
int namesize;
/* Extract the actual part from the pathname. */
next = pupa_strchr (name, '/');
if (next)
{
next[0] = '\0';
next++;
}
namesize = pupa_strlen (name);
/* Open the file. */
pupa_ext2_read_inode (data, currinode, inode);
if (pupa_errno)
goto fail;
/* Search the file. */
while (fpos < pupa_le_to_cpu32 (inode->size))
{
struct ext2_dirent dirent;
/* Read the directory entry. */
pupa_ext2_read_file (data, fpos, sizeof (struct ext2_dirent),
(char *) &dirent);
if (pupa_errno)
goto fail;
if (dirent.namelen != 0)
{
char filename[dirent.namelen + 1];
/* Read the filename part of this directory entry. */
pupa_ext2_read_file (data, fpos
+ sizeof (struct ext2_dirent),
dirent.namelen, filename);
if (pupa_errno)
goto fail;
filename[dirent.namelen] = '\0';
/* Check if the current directory entry described the
file we are looking for. */
if (dirent.namelen == namesize
&& !pupa_strncmp (name, filename, namesize))
{
/* If this is a symlink, follow it. */
if (dirent.filetype == FILETYPE_SYMLINK)
{
/* XXX: Use malloc instead? */
char symlink[blocksize];
if (++symlinkcnt == EXT2_MAX_SYMLINKCNT)
{
pupa_error (PUPA_ERR_SYMLINK_LOOP,
"too deep nesting of symlinks");
goto fail;
}
/* Read the symlink. */
pupa_ext2_read_inode (data,
pupa_le_to_cpu32 (dirent.inode),
inode);
/* If the filesize of the symlink is bigger than
60 the symlink is stored in a separate block,
otherwise it is stored in the inode. */
if (pupa_le_to_cpu32 (inode->size) <= 60)
pupa_strncpy (symlink,
inode->symlink,
pupa_le_to_cpu32 (inode->size));
else
{
pupa_ext2_read_file (data, 0,
pupa_le_to_cpu32 (inode->size),
symlink);
if (pupa_errno)
goto fail;
}
symlink[pupa_le_to_cpu32 (inode->size)] = '\0';
/* Check if the symlink is absolute or relative. */
if (symlink[0] == '/')
{
pupa_strncpy (fpath, symlink, EXT2_PATH_MAX);
name = fpath;
currinode = 2;
}
else
{
char *bak = 0;
if (next)
{
bak = pupa_strdup (next);
if (!bak)
goto fail;
}
/* Relative symlink, construct the new path. */
pupa_strcpy (fpath, symlink);
name = fpath;
if (next)
{
pupa_strcat (name, "/");
pupa_strcat (name, bak);
pupa_free (bak);
}
}
fpos = 0;
break;
}
if (next)
{
currinode = pupa_le_to_cpu32 (dirent.inode);
name = next;
if (dirent.filetype != FILETYPE_DIRECTORY)
{
pupa_error (PUPA_ERR_BAD_FILE_TYPE,
"not a directory");
goto fail;
}
break;
}
else /* Found it! */
{
*ino = pupa_le_to_cpu32 (dirent.inode);
return 0;
}
}
}
/* Move to next directory entry. */
fpos += pupa_le_to_cpu16 (dirent.direntlen);
}
/* The complete directory was read and no matching file was
found. */
if (fpos >= pupa_le_to_cpu32 (inode->size))
{
pupa_error (PUPA_ERR_FILE_NOT_FOUND, "file not found");
goto fail;
}
}
fail:
return pupa_errno;
}
/* Open a file named NAME and initialize FILE. */
static pupa_err_t
pupa_ext2_open (struct pupa_file *file, const char *name)
{
struct pupa_ext2_data *data;
int ino;
#ifndef PUPA_UTIL
pupa_dl_ref (my_mod);
#endif
data = pupa_ext2_mount (file->device->disk);
if (!data)
goto fail;
pupa_ext2_find_file (data, name, &ino);
if (pupa_errno)
goto fail;
pupa_ext2_read_inode (data, ino, &data->inode);
if (pupa_errno)
goto fail;
if (!(pupa_le_to_cpu16 (data->inode.mode) & 0100000))
{
pupa_error (PUPA_ERR_BAD_FILE_TYPE, "not a regular file");
goto fail;
}
file->size = pupa_le_to_cpu32 (data->inode.size);
file->data = data;
file->offset = 0;
return 0;
fail:
pupa_free (data);
#ifndef PUPA_UTIL
pupa_dl_unref (my_mod);
#endif
return pupa_errno;
}
static pupa_err_t
pupa_ext2_close (pupa_file_t file)
{
pupa_free (file->data);
#ifndef PUPA_UTIL
pupa_dl_unref (my_mod);
#endif
return pupa_errno;
}
/* Read LEN bytes data from FILE into BUF. */
static pupa_ssize_t
pupa_ext2_read (pupa_file_t file, char *buf, pupa_ssize_t len)
{
struct pupa_ext2_data *data =
(struct pupa_ext2_data *) file->data;
return pupa_ext2_read_file (data, file->offset, len, buf);
}
static pupa_err_t
pupa_ext2_dir (pupa_device_t device, const char *path,
int (*hook) (const char *filename, int dir))
{
struct pupa_ext2_data *data = 0;;
int ino;
unsigned int fpos = 0;
#ifndef PUPA_UTIL
pupa_dl_ref (my_mod);
#endif
data = pupa_ext2_mount (device->disk);
if (!data)
goto fail;
pupa_ext2_find_file (data, (char *) path, &ino);
if (pupa_errno)
goto fail;
pupa_ext2_read_inode (data, ino, &data->inode);
if (pupa_errno)
goto fail;
if (!(pupa_le_to_cpu16 (data->inode.mode) & 040000))
{
pupa_error (PUPA_ERR_BAD_FILE_TYPE, "not a directory");
goto fail;
}
/* Search the file. */
while (fpos < pupa_le_to_cpu32 (data->inode.size))
{
struct ext2_dirent dirent;
pupa_ext2_read_file (data, fpos, sizeof (struct ext2_dirent),
(char *) &dirent);
if (pupa_errno)
goto fail;
if (dirent.namelen != 0)
{
char filename[dirent.namelen + 1];
pupa_ext2_read_file (data, fpos + sizeof (struct ext2_dirent),
dirent.namelen, filename);
if (pupa_errno)
goto fail;
filename[dirent.namelen] = '\0';
hook (filename, dirent.filetype == FILETYPE_DIRECTORY);
}
fpos += pupa_le_to_cpu16 (dirent.direntlen);
}
fail:
pupa_free (data);
#ifndef PUPA_UTIL
pupa_dl_unref (my_mod);
#endif
return pupa_errno;
}
static struct pupa_fs pupa_ext2_fs =
{
.name = "ext2",
.dir = pupa_ext2_dir,
.open = pupa_ext2_open,
.read = pupa_ext2_read,
.close = pupa_ext2_close,
.next = 0
};
#ifdef PUPA_UTIL
void
pupa_ext2_init (void)
{
pupa_fs_register (&pupa_ext2_fs);
}
void
pupa_ext2_fini (void)
{
pupa_fs_unregister (&pupa_ext2_fs);
}
#else /* ! PUPA_UTIL */
PUPA_MOD_INIT
{
pupa_fs_register (&pupa_ext2_fs);
my_mod = mod;
}
PUPA_MOD_FINI
{
pupa_fs_unregister (&pupa_ext2_fs);
}
#endif /* ! PUPA_UTIL */

View File

@ -2,6 +2,7 @@
/*
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
* Copyright (C) 2002 Marco Gerards <metgerards@student.han.nl>
*
* PUPA is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
@ -48,6 +49,7 @@ typedef enum
PUPA_ERR_NO_KERNEL,
PUPA_ERR_BAD_FONT,
PUPA_ERR_NOT_IMPLEMENTED_YET,
PUPA_ERR_SYMLINK_LOOP
}
pupa_err_t;

View File

@ -2,6 +2,7 @@
/*
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
* Copyright (C) 2003 Marco Gerards <metgerards@student.han.nl>
*
* PUPA is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
@ -30,8 +31,13 @@
void *EXPORT_FUNC(pupa_memmove) (void *dest, const void *src, pupa_size_t n);
char *EXPORT_FUNC(pupa_strcpy) (char *dest, const char *src);
char *EXPORT_FUNC(pupa_strncpy) (char *dest, const char *src, int c);
char *EXPORT_FUNC(pupa_strcat) (char *dest, const char *src);
int EXPORT_FUNC(pupa_memcmp) (const void *s1, const void *s2, pupa_size_t n);
int EXPORT_FUNC(pupa_strcmp) (const char *s1, const char *s2);
int EXPORT_FUNC(pupa_strncmp) (const char *s1, const char *s2, int c);
char *EXPORT_FUNC(pupa_strchr) (const char *s, int c);
char *EXPORT_FUNC(pupa_strrchr) (const char *s, int c);
int EXPORT_FUNC(pupa_isspace) (int c);

View File

@ -1,6 +1,7 @@
/*
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
* Copyright (C) 2003 Marco Gerards <metgerards@student.han.nl>
*
* PUPA is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
@ -350,6 +351,8 @@ pupa_disk_read (pupa_disk_t disk, unsigned long sector,
/* Uggh... Failed. Instead, just read necessary data. */
unsigned num;
pupa_errno = PUPA_ERR_NONE;
/* If more data is required, no way. */
if (pos + size
>= (PUPA_DISK_SECTOR_SIZE << PUPA_DISK_CACHE_BITS))

View File

@ -3,6 +3,7 @@
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 1999,2000,2001,2002 Free Software Foundation, Inc.
* Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
* Copyright (C) 2003 Marco Gerards <metgerards@student.han.nl>
*
* PUPA is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
@ -57,7 +58,18 @@ pupa_strcpy (char *dest, const char *src)
return dest;
}
#if 0
char *
pupa_strncpy (char *dest, const char *src, int c)
{
char *p = dest;
int pos = 0;
while ((*p++ = *src++) != '\0' && c > pos)
pos++;
return dest;
}
char *
pupa_strcat (char *dest, const char *src)
{
@ -71,7 +83,6 @@ pupa_strcat (char *dest, const char *src)
return dest;
}
#endif
int
pupa_printf (const char *fmt, ...)
@ -125,6 +136,24 @@ pupa_strcmp (const char *s1, const char *s2)
return (int) *s1 - (int) *s2;
}
int
pupa_strncmp (const char *s1, const char *s2, int c)
{
int p = 1;
while (*s1 && *s2 && p < c)
{
if (*s1 != *s2)
return (int) *s1 - (int) *s2;
s1++;
s2++;
p++;
}
return (int) *s1 - (int) *s2;
}
char *
pupa_strchr (const char *s, int c)
{

View File

@ -3,6 +3,7 @@
* PUPA -- Preliminary Universal Programming Architecture for GRUB
* Copyright (C) 1999,2000,2001,2002 Free Software Foundation, Inc.
* Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
* Copyright (C) 2003 Marco Gerards <metgerards@student.han.nl>
*
* PUPA is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
@ -26,11 +27,6 @@
#include <pupa/err.h>
#include <pupa/util/misc.h>
/* Try to use glibc's transparant LFS support. */
#define _LARGEFILE_SOURCE 1
/* lseek becomes synonymous with lseek64. */
#define _FILE_OFFSET_BITS 64
#include <stdio.h>
#include <stdlib.h>
#include <string.h>